//=============================================================================
//
// file :        XPAD.h
//
// description : Include for the XPAD class.
//
// project :	Image treatment necessary to adjust a beamline during experiments coherences.
//
// $Author: picca $
//
// $Revision: 1.11 $
//
// $Log: XPAD.h,v $
// Revision 1.11  2009/03/25 14:12:33  picca
// * add the exposure attribute
//
// Revision 1.10  2009/03/25 13:07:08  picca
// * rename the intensity -> intensities
// * add a new intensity scalar attribute #12131
//
// Revision 1.9  2008/12/11 14:52:05  picca
// * add the intensity attribute
//
// Revision 1.8  2008/06/02 14:38:19  picca
// * first working version
//
// Revision 1.6  2008/03/04 14:12:28  picca
// * now it works with the TangoTest od acqAndor Device
//
// Revision 1.5  2008/02/22 15:43:16  picca
// * the DarkAcquisition method is working
//
// Need to add a convertion from UINT to USHORT in the xrays library. The Start command do not work now.
//
// Revision 1.4  2008/02/22 10:16:07  picca
// * use a DevLong for the image attribut instead of DevULong
//
// Revision 1.3  2008/02/21 17:02:53  picca
// * first linux compilable version
//
// Revision 1.2  2008/02/14 11:51:17  elattaoui
// Start and DarkAcquisition commands added
//
// Revision 1.1  2008/01/23 15:25:39  le
// initial import
//
//
// copyleft :    European Synchrotron Radiation Facility
//               BP 220, Grenoble 38043
//               FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _XPAD_H
#define _XPAD_H

#include <tango.h>
#include "XPADTask.h"

//using namespace Tango;

/**
 * @author	$Author: picca $
 * @version	$Revision: 1.11 $
 */

 //	Add your own constants definitions here.
 //-----------------------------------------------

namespace XPAD_ns
{

/**
 * Class Description:
 * Class used to acquire a number of images and to apply a calculation on each.
 *	The returned result is the accumulation of these processed images.
 */

/*
 *	Device States Description:
 */


class XPAD: public Tango::Device_4Impl
{
public :
	//	Add your own data members here
	//-----------------------------------------


	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attributs member data.
 */
//@{
		Tango::DevDouble	*attr_exposure_read;
		Tango::DevDouble	attr_exposure_write;
		Tango::DevLong	*attr_gateNumber_read;
		Tango::DevLong	attr_gateNumber_write;
		Tango::DevLong	*attr_gateMode_read;
		Tango::DevLong	attr_gateMode_write;
		Tango::DevLong	*attr_image_read;
		Tango::DevLong	*attr_dacl_read;
		Tango::DevLong	attr_dacl_write;
		Tango::DevLong	*attr_ithl_read;
		Tango::DevLong	attr_ithl_write;
		Tango::DevLong	*attr_Itune_read;
		Tango::DevLong	attr_Itune_write;
		Tango::DevLong	*attr_Imfp_read;
		Tango::DevLong	attr_Imfp_write;
//@}

/**
 *	@name Device properties
 *	Device properties member data.
 */
//@{
/**
 *	type of the XPAD connected to the device.
 *	values: "500k", "single_module", "QuadCdTe"
 */
	string	type;
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	XPAD(Tango::DeviceClass *cl,string &s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	XPAD(Tango::DeviceClass *cl,const char *s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	XPAD(Tango::DeviceClass *cl,const char *s,const char *d);
//@}

/**@name Destructor
 * Only one desctructor is defined for this class */
//@{
/**
 * The object desctructor.
 */	
	~XPAD() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method befor execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name XPAD methods prototypes
 */

//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values for exposure acquisition result.
 */
	virtual void read_exposure(Tango::Attribute &attr);
/**
 *	Write exposure attribute values to hardware.
 */
	virtual void write_exposure(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for gateNumber acquisition result.
 */
	virtual void read_gateNumber(Tango::Attribute &attr);
/**
 *	Write gateNumber attribute values to hardware.
 */
	virtual void write_gateNumber(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for gateMode acquisition result.
 */
	virtual void read_gateMode(Tango::Attribute &attr);
/**
 *	Write gateMode attribute values to hardware.
 */
	virtual void write_gateMode(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for image acquisition result.
 */
	virtual void read_image(Tango::Attribute &attr);
/**
 *	Extract real attribute values for dacl acquisition result.
 */
	virtual void read_dacl(Tango::Attribute &attr);
/**
 *	Write dacl attribute values to hardware.
 */
	virtual void write_dacl(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for ithl acquisition result.
 */
	virtual void read_ithl(Tango::Attribute &attr);
/**
 *	Write ithl attribute values to hardware.
 */
	virtual void write_ithl(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Itune acquisition result.
 */
	virtual void read_Itune(Tango::Attribute &attr);
/**
 *	Write Itune attribute values to hardware.
 */
	virtual void write_Itune(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Imfp acquisition result.
 */
	virtual void read_Imfp(Tango::Attribute &attr);
/**
 *	Write Imfp attribute values to hardware.
 */
	virtual void write_Imfp(Tango::WAttribute &attr);
/**
 *	Read/Write allowed for exposure attribute.
 */
	virtual bool is_exposure_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for gateNumber attribute.
 */
	virtual bool is_gateNumber_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for gateMode attribute.
 */
	virtual bool is_gateMode_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for image attribute.
 */
	virtual bool is_image_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for dacl attribute.
 */
	virtual bool is_dacl_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for ithl attribute.
 */
	virtual bool is_ithl_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Itune attribute.
 */
	virtual bool is_Itune_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Imfp attribute.
 */
	virtual bool is_Imfp_allowed(Tango::AttReqType type);
/**
 *	Execution allowed for Start command.
 */
	virtual bool is_Start_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for Stop command.
 */
	virtual bool is_Stop_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for LoadCalibration command.
 */
	virtual bool is_LoadCalibration_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for Reset command.
 */
	virtual bool is_Reset_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for Calibrate command.
 */
	virtual bool is_Calibrate_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for LoadFlatDacl command.
 */
	virtual bool is_LoadFlatDacl_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for LoadDefaultConfigG command.
 */
	virtual bool is_LoadDefaultConfigG_allowed(const CORBA::Any &any);
/**
 * This command gets the device state (stored in its <i>device_state</i> data member) and returns it to the caller.
 *	@return	State Code
 *	@exception DevFailed
 */
	virtual Tango::DevState	dev_state();
/**
 * This command gets the device status (stored in its <i>device_status</i> data member) and returns it to the caller.
 *	@return	Status description
 *	@exception DevFailed
 */
	virtual Tango::ConstDevString	dev_status();
/**
 * Start the images treatment
 *	@exception DevFailed
 */
	void	start();
/**
 * Stop the images treatment
 *	@exception DevFailed
 */
	void	stop();
/**
 * 
 *	@param	argin	
 *	@exception DevFailed
 */
	void	load_calibration(Tango::DevString);
/**
 * Reset the hub and the modules of the xpad
 *	@exception DevFailed
 */
	void	reset();
/**
 * do a calibration à la marseillaise :)
 *	@param	argin	parameters of the calibration\nstring path // useless for now\nlong: ith_min, ith_max, algo, noise, decalage\n
 *	@exception DevFailed
 */
	void	calibrate(const Tango::DevVarLongStringArray *);
/**
 * send to the xpad the default general configurations.
 *	ithl, ithune, imfp, ...
 *	@param	argin	value to set
 *	@exception DevFailed
 */
	void	load_flat_dacl(Tango::DevULong);
/**
 * send to the xpad the default general configurations.
 *	ithl, ithune, imfp, ...
 *	@exception DevFailed
 */
	void	load_default_config_g();

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	



protected :	
	//	Add your own data members here
	//-----------------------------------------
	XPADTask *_dev_task;
};

}	// namespace_ns

#endif	// _XPAD_H
